<template>
    <transition
        enter-active-class="animated slideOutLeft"
        leave-active-class="animated slideOutRight"
    >
        <div class="notification"
             v-if="$notifications.display"
             @mouseover="pauseTimer"
             @mouseleave="resumeTimer"
             style="z-index: 2147483647"
             :class="{hidden: !$notifications.display}"
        >
            <div class="notification__wrapper" :class="{['notification-type-'+$notifications.messageType]: true}">
                <div class="notification_title">
                    <div class="notification_title-icon" >
                        <SVGIcon :xlink="xlink" :fill="fill" viewBox="0 0 20 20"></SVGIcon>
                    </div>
                    <div class="notification_title-text">
                        {{$notifications.messageTitle}}
                    </div>

                    <div class="notification_title-close" @click="close">
                        <SVGIcon xlink="close-45" viewBox="0 0 45 45" :fill="$theme.colors.label"></SVGIcon>
                    </div>
                </div>

                <div class="notification_timer">
                    <div class="notification_timer-line" :style="timerStyle"></div>
                </div>

                <div class="notification_text" v-html="$notifications.messageText"></div>

                <div class="notification_buttons" v-if="$notifications.buttons">
                    <div v-for="button in $notifications.buttons"
                            :key="button.title"
                            class="button"
                            :class="{link: button.type === 'link'}"
                            @click="buttonHandler(button)"
                    >
                        {{button.title}}
                    </div>
                </div>

            </div>
        </div>
    </transition>
</template>

<script>
    import SVGIcon from '@/components/SVGIcon'
    export default {
        name: 'component-notification',
        components: {
            SVGIcon
        },
        data () {
            return {
                timeout: this.$theme.notifications.timeout,
                showTime: 0
            }
        },
        computed: {
            xlink () {
                switch(this.$notifications.messageType) {
                    case 'warning':
                        return 'warning-icon';
                    case 'success':
                        return 'success-icon';
                    case 'error':
                        return 'error-icon';
                    default:
                        return 'warning-icon';
                }
            },

            fill () {
                return this.timerColor;
            },

            timerStyle () {
                return {
                    width: this.timerWidth,
                    'background-color': this.timerColor
                }
            },

            timerWidth () {
                return (this.showTime / this.timeout * 100).toFixed(2) + '%'
            },

            timerColor () {
                return {
                    success: this.$theme.colors.statusGreen,
                    error: this.$theme.colors.statusRed,
                    warning: this.$theme.colors.yellow,
                    message: this.$theme.colors.blue,
                }[this.$notifications.messageType] || this.$theme.colors.statusAwait;
            }

        },

        watch: {
            '$notifications': {
                deep: true,
                handler (n) {
                    if(n.display) {
                        this.$nextTick(() => {
                            this.reset();
                            this.startTimer();
                        })
                    }
                }
            }
        },

        created () {
            this.showTime = this.timeout;

        },

        methods: {

			/**
             *
			 * @param {iNotificationButton} button
			 */
			buttonHandler(button) {
                if(typeof button.click === "function") {
					button.click();
					this.$store.commit('NOTIFICATION_CLOSE');
                }
            },

            startTimer () {
                if(!this.showTime) return;
                if(!this.$notifications.display) return;

                this.interval = setInterval(() => {

                    if(!this.$notifications.display) {
                        clearInterval(this.interval);
                    }

                    if(!this.showTime) {
                        this.close();
                    }
                    this.showTime = this.showTime - 40;
                }, 40);
            },

            pauseTimer() {
                // console.log('pause timer', this.interval);
                if (this.interval) {
                    clearInterval(this.interval);
                }
            },

            resumeTimer () {
                this.startTimer();
            },

            close () {
                this.$store.commit('NOTIFICATION_CLOSE');
            },


            reset () {
                if(this.interval) {
                    clearInterval(this.interval);
                }
                this.timeout = this.$theme.notifications.timeout;
                this.showTime = this.$theme.notifications.timeout;
            }
        }

    };
</script>

<style scoped>
</style>
